summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2014-09-17 18:50:08 +0100
committerPádraig Brady <P@draigBrady.com>2014-09-19 11:25:23 +0100
commit90aa291c39ca8970fbce310cc317c5cc7b392691 (patch)
tree2613a601eb8ce9970ec2e4bb1bb564a8db3336f4 /tests/cp
parent8e93dc629727140e950a709008f9a17ca461af63 (diff)
downloadcoreutils-90aa291c39ca8970fbce310cc317c5cc7b392691.tar.xz
cp: issue correct warning and ignore duplicate source dirs
* src/copy.c (copy_internal): Handle the case where we have the same destination directory as already encountered, which can only be due to the corresponding source directory being specified multiple times. * tests/cp/duplicate-sources.sh: Add a test for the new multiply specified directory case, and the existing multiply specified file case. * tests/local.mk: Reference the new test. * NEWS: Mention the bug fix.
Diffstat (limited to 'tests/cp')
-rwxr-xr-xtests/cp/duplicate-sources.sh35
1 files changed, 35 insertions, 0 deletions
diff --git a/tests/cp/duplicate-sources.sh b/tests/cp/duplicate-sources.sh
new file mode 100755
index 000000000..e15c6d213
--- /dev/null
+++ b/tests/cp/duplicate-sources.sh
@@ -0,0 +1,35 @@
+#!/bin/sh
+# Ensure cp warns about but otherwise ignores source
+# items specified multiple times.
+
+# Copyright (C) 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ cp
+
+mkdir a b || framework_failure_
+touch f || framework_failure_
+
+cp -a a a f f b 2>err || fail=1
+
+cat <<EOF >exp
+cp: warning: source directory 'a' specified more than once
+cp: warning: source file 'f' specified more than once
+EOF
+
+compare exp err || fail=1
+
+Exit $fail